// compile: gcc convert24to16.c -o convert24to16
// run: ./convert24to16 < image24bpp.raw > image16bpp.raw

#include <stdio.h>
 
int main(int argc, char *argv[])
{
	unsigned long int rgb_in, rgb_out;
	unsigned long int red, green, blue;
 
	while( fread(&rgb_in, 3, 1, stdin)==1 )
	{
		red   = (rgb_in >> 16) & 0xFF;
		green = (rgb_in >>  8) & 0xFF;
		blue  = (rgb_in      ) & 0xFF;
 
		/*red   = red  *31/255;
		green = green*63/255;
		blue  = blue *31/255;*/
 
		red   = red   >> 3;
		green = green >> 2;
		blue  = blue  >> 3;
 
		/*rgb_out = (red << 11) | (green << 5) | blue;*/
		rgb_out = red | (green << 5) | (blue << 11);
		fwrite(&rgb_out, 2, 1, stdout);
	}
	return 0;
}


